//Cteni S.M.A.R.T. informaci z HDD
//www.prochazka.zde.cz

#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <Winbase.h>
#include <stddef.h>
#include <string.h>
#include <winioctl.h>

//#include <d:Ntddk/inc/ntddscsi.h>



//#pragma pack(1)		// Required to ensure correct SMART IOCTL structure setup
#include "smart.h"
#include "smartapp.h"

#define PRINTING_TO_CONSOLE_ALLOWED
//
// Define global buffers.
//
BYTE	AttrOutCmd[sizeof(SENDCMDOUTPARAMS) + READ_ATTRIBUTE_BUFFER_SIZE - 1];
BYTE	ThreshOutCmd[sizeof(SENDCMDOUTPARAMS) + READ_THRESHOLD_BUFFER_SIZE - 1];
BYTE	IdOutCmd[sizeof(SENDCMDOUTPARAMS) + IDENTIFY_BUFFER_SIZE - 1];

true = 1;
false = 0;


//int TypDisku = 2; /*0 = PRIMARYMASTER
/*					 1 = PRIMARYSLAVE
					 2 = SECONDARYMASTER
					 3 = SECONDARYSLAVE*/

//int FyzickyDisk = 0; /*cislo fyzickedo disku*/


int main()
{
	HddInfo();
	return 0;
}
/*******************************************************************************/
void HddInfo (void)
{
	STORAGE_PROPERTY_QUERY query;
	char buffer [2000];
	int rnt =0;
	DWORD cbBytesReturned = 0;
	int done = FALSE;
	int drive = 0;
	HANDLE hPhysicalDriveIOCTL = 0;
	char driveName [256];
	STORAGE_DEVICE_DESCRIPTOR * descrip = (STORAGE_DEVICE_DESCRIPTOR *) & buffer;
	//////////////
	DISK_GEOMETRY pdg;            // disk drive geometry structure
	ULONGLONG DiskSize;           // size of the drive, in bytes
	/////////////
	GETVERSIONINPARAMS VersionParams;
	//////////////////
	SENDCMDINPARAMS 	pSCIP;
	SENDCMDOUTPARAMS	OutCmd;
	BYTE				bDfpDriveMap = 0;
	BYTE				i;
	long ErrorKod = 0;
	DWORD ErrorKod1 = 0;
	//////////////
	MEDIA_SERIAL_NUMBER_DATA sn;
	////////////////
	BYTE				bIDCmd;		// IDE or ATAPI IDENTIFY cmd
	////////////////
	BYTE	AttrOutCmd[sizeof(SENDCMDOUTPARAMS) + READ_ATTRIBUTE_BUFFER_SIZE + 2000];
	BYTE	ThreshOutCmd[sizeof(SENDCMDOUTPARAMS) + READ_THRESHOLD_BUFFER_SIZE + 2000];

	BYTE	bSuccess = 1;
	WORD n_wStatusFlags = 0;
	int	ii;
	PDRIVEATTRIBUTE	pDA;
	PATTRTHRESHOLD	pAT;
	BYTE Attr;
	PCHAR pAttrBuffer;
	PCHAR pThrsBuffer;

	
	for (drive = 0; drive < MAX_IDE_DRIVES; drive++)
	{
		sprintf (driveName, "\\\\.\\PhysicalDrive%d", drive);

//           Windows NT, Windows 2000, Windows XP - admin rights not required
		hPhysicalDriveIOCTL = CreateFile (driveName, GENERIC_READ | GENERIC_WRITE,
								FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
								OPEN_EXISTING, 0, NULL);
//		hPhysicalDriveIOCTL = CreateFile ("\\\\.\\Scsi0:", GENERIC_READ | GENERIC_WRITE,
//	                               FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
//	                               OPEN_EXISTING, 0, NULL);

		if (hPhysicalDriveIOCTL != INVALID_HANDLE_VALUE)
		{
/*******************************************************************************/
//Verze SMART
			memset((void*)&VersionParams, 0, sizeof(VersionParams));

			if ( DeviceIoControl(hPhysicalDriveIOCTL, SMART_GET_VERSION, NULL, 0, &VersionParams, sizeof(VersionParams), &cbBytesReturned, NULL) ){

				printf("SMART_GET_VERSION returned:\n");
				printf("\tbVersion        = %d\n", VersionParams.bVersion);
				printf("\tbRevision       = %d\n", VersionParams.bRevision);
				printf("\tfCapabilities   = 0x%lx\n", VersionParams.fCapabilities);
				printf("\tbReserved       = 0x%x\n", VersionParams.bReserved);
				printf("\tbIDEDeviceMap   = 0x%x\n", VersionParams.bIDEDeviceMap);
				printf("\tcbBytesReturned = %d\n\n", cbBytesReturned);

				if (VersionParams.fCapabilities == CAP_IDE_ID_FUNCTION){
					printf("\nCAP_IDE_ID_FUNCTION\n");
				}
				if (VersionParams.fCapabilities == CAP_IDE_ATAPI_ID){
					printf("\nCAP_IDE_ATAPI_ID\n");
				}
				if (VersionParams.fCapabilities == CAP_IDE_EXECUTE_SMART_FUNCTION){
					printf("\nCAP_IDE_EXECUTE_SMART_FUNCTION\n");
				}

			}
			else
			{
				printf("DFP_GET_VERSION failed.\n");
			}
/*******************************************************************************/
//Zisti Model a Firmvare revision HDD
			query.PropertyId = StorageDeviceProperty;
			query.QueryType = PropertyStandardQuery;

			memset (buffer, 0, sizeof (buffer));

			rnt = DeviceIoControl (hPhysicalDriveIOCTL, IOCTL_STORAGE_QUERY_PROPERTY, & query, sizeof (query), & buffer, sizeof (buffer), & cbBytesReturned, NULL);

			printf ("\n Model: %s%s", & buffer [descrip-> VendorIdOffset], & buffer [descrip-> ProductIdOffset]);
			printf ("\n Firmvare revision: %s", & buffer [ descrip-> ProductRevisionOffset]);
//			printf ("\n Serial Number: %s", serialNumber); 
/*******************************************************************************/
//Zisti Infornace o HDD
			rnt = DeviceIoControl(hPhysicalDriveIOCTL,  // device we are querying
				IOCTL_DISK_GET_DRIVE_GEOMETRY,  // operation to perform
				NULL, 0, // no input buffer, so pass zero
				&pdg, sizeof(pdg),  // output buffer
				& cbBytesReturned, // discard count of bytes returned
				(LPOVERLAPPED) NULL);  // synchronous I/O

			if (rnt) {
				printf("\nCylinders = %I64d", pdg.Cylinders);
				printf("\nTracks per cylinder = %ld", (ULONG) pdg.TracksPerCylinder);
				printf("\nSectors per track = %ld", (ULONG) pdg.SectorsPerTrack);
				printf("\nBytes per sector = %ld", (ULONG) pdg.BytesPerSector);
				DiskSize = 0;
				DiskSize = pdg.Cylinders.QuadPart * (ULONG)pdg.TracksPerCylinder * (ULONG)pdg.SectorsPerTrack * (ULONG)pdg.BytesPerSector;
				printf("\nDisk size = %I64d (Bytes) = %I64d (Mb)", DiskSize, DiskSize / (1024 * 1024));

			} else{
				printf ("Attempt to get drive geometry failed. Error %ld.\n", GetLastError ());
			}

/*******************************************************************************/
			for (i =0; i<4; i++){
				if (VersionParams.bIDEDeviceMap >> i & 1) // test na IDE zarizeni
					{
						//
						// Try to enable SMART so we can tell if a drive supports it.
						// Ignore ATAPI devices.
						//
					if (!(VersionParams.bIDEDeviceMap >> i & 0x10)) //Test na ATAPI zarizeni
					{
/********************************************************************************/
// Zapne SMART
						memset(&pSCIP, 0, sizeof(pSCIP)); //vyplni pole scip nulou
						memset (buffer, 0, sizeof (buffer));
						memset (&OutCmd, 0, sizeof (OutCmd));
						memset (&OutCmd.DriverStatus, 0, sizeof (IDEREGS));
				
						pSCIP.cBufferSize = sizeof(OutCmd);

						pSCIP.irDriveRegs.bFeaturesReg = SMART_ENABLE_SMART_OPERATIONS;
						pSCIP.irDriveRegs.bSectorCountReg = 1; 
						pSCIP.irDriveRegs.bSectorNumberReg = 1;
						pSCIP.irDriveRegs.bCylLowReg = SMART_CYL_LOW;
						pSCIP.irDriveRegs.bCylHighReg = SMART_CYL_HI;
						//
						// Compute the drive number.
						//
						pSCIP.irDriveRegs.bDriveHeadReg = 0xA0 | ((i & 1) << 4) ; 
						pSCIP.irDriveRegs.bCommandReg = IDE_EXECUTE_SMART_FUNCTION;
						pSCIP.bDriveNumber = i;

						ErrorKod =  DeviceIoControl(hPhysicalDriveIOCTL, SMART_SEND_DRIVE_COMMAND,
							&pSCIP, sizeof(pSCIP) + sizeof(IDEREGS),
               				buffer, sizeof(buffer),
							&cbBytesReturned, NULL);

						ErrorKod1 = GetLastError();
							
						if (ErrorKod == true){
							printf("\nSMART Enabled on Drive: %d", i);
							//
							// Mark the drive as SMART enabled
							//
							bDfpDriveMap |= (1 << i);
							printf("%s\n", ( bDfpDriveMap >> i & 1) ? \
								" that supports SMART" : "");
						}
						else
	    				{
							printf("\nSMART Enable Command Failed, Drive: %d.",i);
	    				}
				
/*******************************************************************************/
//Zisti Seriove cislo HDD
						memset (buffer, 0, sizeof (buffer));

						ErrorKod =  DeviceIoControl (hPhysicalDriveIOCTL, IOCTL_STORAGE_GET_MEDIA_SERIAL_NUMBER,
								NULL, 0,  &sn, sizeof (sn), & cbBytesReturned, NULL);
						ErrorKod1 = GetLastError();
						if(ErrorKod == false){
							printf("\nSN FAILED, Error kod:  %d", ErrorKod1);
						}
						else{
							printf("\nSN OK %d", cbBytesReturned);
						}
/*******************************************************************************/
//Pokus Znovu zistit Informace o HDD, ale fungujeto nejak divne, Nejspis chyba ve Win.
//Vysledek dotazu je hodne zavysly na konfiguraci PC. Pokazde se dostane jinych vysledku.
//Napr. v PC jsou dva odlisne HDD ale tato API funkce tvrdi ze jsou oba totozne.
//					for (i =0; i<4; i++)
//					{
						memset (buffer, 0, sizeof (buffer));
						memset (&OutCmd, 0, sizeof (OutCmd));
						memset (&OutCmd.DriverStatus, 0, sizeof (IDEREGS));

						bIDCmd = (VersionParams.bIDEDeviceMap >> i & 0x10) ? \
										IDE_ATAPI_ID : IDE_ID_FUNCTION;
						pSCIP.cBufferSize = IDENTIFY_BUFFER_SIZE;
						pSCIP.irDriveRegs.bFeaturesReg = 0; //READ_ATTRIBUTES
						pSCIP.irDriveRegs.bSectorCountReg = 1;
						pSCIP.irDriveRegs.bSectorNumberReg = 1;
						pSCIP.irDriveRegs.bCylLowReg = SMART_CYL_LOW; //SMART_CYL_LOW
						pSCIP.irDriveRegs.bCylHighReg = SMART_CYL_HI; //SMART_CYL_HI

						//
						// Compute the drive number.
						//
						pSCIP.irDriveRegs.bDriveHeadReg = 0xA0 | ((i & 1) << 4) ; 

						pSCIP.irDriveRegs.bCommandReg = bIDCmd;
						pSCIP.bDriveNumber = i;

						ErrorKod =  DeviceIoControl(hPhysicalDriveIOCTL, DFP_RECEIVE_DRIVE_DATA,
             				&pSCIP, sizeof(pSCIP) + sizeof(IDEREGS),
               				buffer, sizeof(buffer),
               				&cbBytesReturned, NULL);

						ErrorKod1 = GetLastError();
						if(ErrorKod == false){
							printf("\nIDENTIFY FAILED, Error kod:  %d", ErrorKod1);
						}
						else{
							printf("\nIDENTIFY OK %d", cbBytesReturned);
						}
//					}
/*******************************************************************************/
//Cteni SMART ATRIBUTU
//					for (i = 0; i < MAX_IDE_DRIVES; i++)
//					{
//						if (bDfpDriveMap >> i & 1)
//						{

						memset(AttrOutCmd, 0, sizeof(AttrOutCmd));
						memset(ThreshOutCmd, 0, sizeof(ThreshOutCmd));


						pSCIP.cBufferSize = READ_ATTRIBUTE_BUFFER_SIZE;

						pSCIP.irDriveRegs.bFeaturesReg = SMART_READ_ATTRIBUTE_VALUES;
						pSCIP.irDriveRegs.bSectorCountReg = 1;
						pSCIP.irDriveRegs.bSectorNumberReg = 1;
						pSCIP.irDriveRegs.bCylLowReg = SMART_CYL_LOW;
						pSCIP.irDriveRegs.bCylHighReg = SMART_CYL_HI;

						//
						// Compute the drive number.
						//
						pSCIP.irDriveRegs.bDriveHeadReg = 0xA0 | ((i & 1) << 4); 
						pSCIP.irDriveRegs.bCommandReg = IDE_EXECUTE_SMART_FUNCTION;
						pSCIP.bDriveNumber = i;


						bSuccess = DeviceIoControl(hPhysicalDriveIOCTL, DFP_RECEIVE_DRIVE_DATA,
							&pSCIP, sizeof(pSCIP) - 1,
							(PSENDCMDOUTPARAMS)&AttrOutCmd, sizeof(AttrOutCmd),
							&cbBytesReturned, NULL);

						if (bSuccess == false){
							printf("\nSMART Read Attr Command Failed on Drive: %d.\n", i);
							printf(" DriverStatus: bDriverError=0x%X, bIDEStatus=0x%X\n\n", 
								((PSENDCMDOUTPARAMS)AttrOutCmd)->DriverStatus.bDriverError, 
								((PSENDCMDOUTPARAMS)AttrOutCmd)->DriverStatus.bIDEStatus);
						}	

// ReadAttributes worked. Try ReadThresholds.
						else {

						pSCIP.cBufferSize = READ_THRESHOLD_BUFFER_SIZE;

						pSCIP.irDriveRegs.bFeaturesReg = SMART_READ_ATTRIBUTE_THRESHOLDS;
						pSCIP.irDriveRegs.bSectorCountReg = 1;
						pSCIP.irDriveRegs.bSectorNumberReg = 1;
						pSCIP.irDriveRegs.bCylLowReg = SMART_CYL_LOW;
						pSCIP.irDriveRegs.bCylHighReg = SMART_CYL_HI;

						//
						// Compute the drive number.
						//
						pSCIP.irDriveRegs.bDriveHeadReg = 0xA0 | ((i & 1) << 4); 
						pSCIP.irDriveRegs.bCommandReg = IDE_EXECUTE_SMART_FUNCTION;
						pSCIP.bDriveNumber = i;


						rnt = DeviceIoControl(hPhysicalDriveIOCTL, DFP_RECEIVE_DRIVE_DATA,
							&pSCIP, sizeof(pSCIP) - 1,
							(PSENDCMDOUTPARAMS)&ThreshOutCmd, sizeof(ThreshOutCmd),
							&cbBytesReturned, NULL);


						if (rnt == false){
							printf("\nSMART Read Thrsh Command Failed on Drive: %d.\n", i);
							printf(" DriverStatus: bDriverError=0x%X, bIDEStatus=0x%X\n\n", 
								((PSENDCMDOUTPARAMS)ThreshOutCmd)->DriverStatus.bDriverError, 
								((PSENDCMDOUTPARAMS)ThreshOutCmd)->DriverStatus.bIDEStatus);
						}

						//
						// The following report will print if ReadAttributes works.
						// If ReadThresholds works, the report will also show values for
						// Threshold values.
						//
						if (bSuccess)
						{
 							pAttrBuffer = ((PSENDCMDOUTPARAMS)AttrOutCmd)->bBuffer;
							pThrsBuffer = ((PSENDCMDOUTPARAMS)ThreshOutCmd)->bBuffer;

							//
							// Print the drive number
							//
							printf("\nData for Drive Number %d\n", i);
							//
							// Print the revisions of the data structures
							//
							printf("Attribute Structure Revision          Threshold Structure Revision\n");
							printf("             %d                                      %d\n\n", 
										(WORD)pAttrBuffer[0], (WORD)pThrsBuffer[0]);

//Jak st a interpretovat jednotliv hodnoty? V ppad trojice daj: 
//prahov hodnota, aktuln hodnota, nejhor hodnota (Treshold, Value, Worst) je pravidlem, 
//e m ni je hodnota, tm he. U vtiny tchto hodnot je maximem 100, u nkterch atribut 200. 
//Pokud se aktuln hodnota dostane pod prahovou hranici (Treshold) znamen to, e disku se vede podprmrn.

							printf("-Attribute Name-     -WarrantyThreshold- -wStatusFlags- -WorstValue- -AttrValue-\n");

							pDA = (PDRIVEATTRIBUTE)&pAttrBuffer[2];
							pAT = (PATTRTHRESHOLD)&pThrsBuffer[2];

							for (ii = 0; ii < NUM_ATTRIBUTE_STRUCTS; ii++)
							{
								Attr = pDA->bAttrID;
								if (Attr)
								{
									if (ATTRIBUTES_C2 > Attr >= UNKNOWN_ATTRIBUTE )Attr = UNKNOWN_ATTRIBUTE;
									if (ATTRIBUTES_C2 <= Attr )Attr = Attr - ATTRIBUTES_C2 + REGISTRY_Cx;
									if (ATTRIBUTES_C2 + END_ATTRIBUTE < Attr) Attr = UNKNOWN_ATTRIBUTE;

									n_wStatusFlags = (pDA->wStatusFlags << 8)|(pDA->wStatusFlags >> 8);

									printf("%2X %-5s%d%5c%d%5c%d%5c%d\n", 
											pDA->bAttrID,
											pAttrNames[Attr], 
											pAT->bWarrantyThreshold, 
											' ',
											n_wStatusFlags,
											' ',
											pDA->bWorstValue,
											' ',
											pDA->bAttrValue );
									}
									pDA++;
									pAT++;
								}

							}
						}
/*******************************************************************************/
					}
				}
			}
			printf("\n-------------------------------------------------\n");
		}	
	}
	  CloseHandle (hPhysicalDriveIOCTL);
}

